#include "clock.h"
#include <iomanip>
#include <iostream>
using namespace std;

void Clock::tick() {
	this->s++;
	if (this->s == 60) this->s = 0, this->m++;
	if (this->m == 60) this->m = 0, this->h++;
	if (this->h == 24) this->h = 0;
}

void Clock::setTime(int h, int m, int s) {
	this->h = (h >= 0 && h <= 23) ? h : 0;
	this->m = (m >= 0 && m <= 59) ? m : 0;
	this->s = (s >= 0 && s <= 59) ? s : 0;
}

void Clock::printTime() {
	cout << setw(2) << setfill('0') << this->h << ':'
		<< setw(2) << setfill('0') << this->m << ':'
		<< setw(2) << setfill('0') << this->s << endl;
}

Clock::Clock() {
	setTime(0, 0, 0);
}

Clock::Clock(int h, int m, int s) {
	setTime(h, m, s);
}