#include "ClockWithDate.h"
#include <iomanip>
#include <iostream>
using namespace std;

// Inicijalizacija objekata izvedenih klasa zapocinje inicijalizacijom nasledjenih polja iz osnovne klase te je potrebno pozvati neki od konstruktora osnovne klase
// Konstruktor se poziva u listi inicijalizatora
ClockWithDate::ClockWithDate() : Clock() {
	setDate(1970, 1, 1);
}

ClockWithDate::ClockWithDate(int y, int m, int d) : Clock() {
	setDate(y, m, d);
}

ClockWithDate::ClockWithDate(int y, int m, int d, int h, int min, int sec) : Clock(h, min, sec) {
	setDate(y, m, d);
}

void ClockWithDate::tick() {
	// Metoda tick klase ClockWithDate prvo poziva metodu tick cija je implementacija u klasi Clock da bi povecala broj sekundi za 1.
	Clock::tick();
	// A zatim se ostatak obrade nastavlja u ovoj metodi
	if (h == 0 && month == 0 && s == 0) {
		day++;
		switch (month) {
		case 1: case 3: case 5: case 7: case 8: case 10: case 12:
			if (day > 31) day = 1, month++;
			break;
		case 4: case 6: case 9: case 11:
			if (day > 30) day = 1, month++;
			break;
		case 2:
			if ((year % 4 == 0 && year % 100 != 0) || year % 400 == 0) {
				if (day > 29) day = 1, month++;
			}
			else {
				if (day > 28) day = 1, month++;
			}
			break;
		}
		if (month > 12) month = 1, year++;
		if (year > 2099) year = 1950;
	}
}

void ClockWithDate::printTime() {
	cout << setw(2) << setfill('0') << this->day << '.'
		<< setw(2) << setfill('0') << this->month << '.'
		<< this->year << ' ';
	// Nakon ispisa datuma, ispis vremena se obavlja pozivom implementacije metode printTime iz klase Clock
	Clock::printTime();
}

void ClockWithDate::setDate(int y, int m, int d) {
	this->year = (y >= 1950 && y <= 2099) ? y : 1950;
	this->month = (m >= 1 && m <= 12) ? m : 1;
	switch (this->month) {
	case 1: case 3: case 5: case 7: case 8: case 10: case 12:
		this->day = (d >= 1 && d <= 31) ? d : 1;
		break;
	case 4: case 6: case 9: case 11:
		this->day = (d >= 1 && d <= 30) ? d : 1;
		break;
	case 2:
		if (this->year % 400 == 0 || (this->year % 4 == 0 && this->year % 100 != 0)) {
			this->day = (d >= 1 && d <= 29) ? d : 1;
		}
		else {
			this->day = (d >= 1 && d <= 28) ? d : 1;
		}
		break;
	}
}
