#ifndef CLOCKWITHDATE_H
#define CLOCKWITHDATE_H

#include "Clock.h"

// Izvodjenje klase ClockWithDate iz klase Clock
// Sva polja i metode iz klase Clock se nasledjuju i implicitno postoje i u klasi ClockWithDate
// Metode koje su u klasi Clock oznacene kao virtuelne, u klasi ClockWithDate mogu da se izmene tako da imaju drugaciju implementaciju (method overriding)
class ClockWithDate : public Clock {
public:
	ClockWithDate();
	ClockWithDate(int y, int m, int d);
	ClockWithDate(int y, int m, int d, int h, int min, int sec);

	// Virtuelne metode tick i printTime nasledjene su iz klase Clock i u klasi ClockWithDate redefinisane
	// Rezervisana rec override naznacava prevodiocu da metoda predstavlja nadjacanje metode koja je nasledjena iz osnovne klase
	// U slucaju da data metoda oznacena sa override ne postoji u osnovnoj klasi ili nije oznacena kao virtuelna, prevodilac javlja gresku
	virtual void tick() override;
	virtual void printTime() override;
	// Metoda setTime je nasledjena iz klase Clock i ne mora da se navodi ovde jer je njena implementacija odgovarajuca i za klasu ClockWithDate
	// Metoda setDate je nova metoda klase ClockWithDate koja nema veze sa osnovnom klasom
	void setDate(int y, int m, int d);

private:
	int year, month, day;
};

#endif