#include "Figure.h"
#include <cmath>

Krug::Krug(double r) {
	this->r = (r > 0.0) ? r : 1.0;
}

double Krug::obim() {
	return 2 * this->r * PI;
}

Pravougaonik::Pravougaonik(double a, double b) {
	this->a = (a > 0.0) ? a : 1.0;
	this->b = (b > 0.0) ? b : 1.0;
}

double Pravougaonik::obim() {
	return 2 * this->a + 2 * this->b;
}

Trougao::Trougao(double a, double b, double c) {
	if (a + b > c && a + c > b && a + b > c) {
		this->a = (a > 0.0) ? a : 1.0;
		this->b = (b > 0.0) ? b : 1.0;
		this->c = (c > 0.0) ? c : 1.0;
	}
	else {
		this->a = this->b = this->c = 1.0;
	}
}

double Trougao::obim() {
	return this->a + this->b + this->c;
}
