#ifndef FIGURE_H
#define FIGURE_H

class Figura {
public:
	// Metoda za koju se ne zna implementacija se oznacava kao apstraktna (ili cisto virtuelna) dodavanjem = 0 u nastavku deklaracije metode.
	// Klase sa makar jednom apstraktnom metodom su i same apstraktne
	// Ne mozemo kreirati objekte apstraktnih klasa
	// Figura* f = new Figura; - prevodilac javlja gresku
	// Apstraktne klase sluze da grupisemo srodne klase (krug, pravougaonik, trougao) u jednu osnovnu klasu, 
	// predvidimo postojanje neke metode (obim) za koju ce postojati konkretne implementacije u izvedenim klasama.
	// Na ovaj nacin mozemo imati kolekcije objekata izvedenih iz figure, tako sto imamo npr. niz pokazivaca na Figuru, pa mozemo da koristimo polimorfizam.
	virtual double obim() = 0;
};

const double PI = 3.14159265358979323846;

class Krug : public Figura {
public:
	Krug(double r);
	virtual double obim() override;

private:
	double r;
};

class Pravougaonik : public Figura {
public:
	Pravougaonik(double a, double b);
	virtual double obim() override;

private:
	double a, b;
};

class Trougao : public Figura {
public:
	Trougao(double a, double b, double c);
	virtual double obim() override;

private:
	double a, b, c;
};

#endif